/*
 * Copyright (C) 2015 MediaTek Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 */

#ifndef _CUST_BATTERY_METER_TABLE_H
#define _CUST_BATTERY_METER_TABLE_H

/* ============================================================*/
/* define*/
/* ============================================================*/
#define BAT_NTC_10 0
#define BAT_NTC_47 0
#define BAT_NTC_100 1

#if (BAT_NTC_10 == 1)
#define RBAT_PULL_UP_R             16900
#define RBAT_PULL_DOWN_R           30000
#endif
#if (BAT_NTC_47 == 1)
#define RBAT_PULL_UP_R             61900
#define RBAT_PULL_DOWN_R           100000
#endif
#if (BAT_NTC_100 == 1)
#define RBAT_PULL_UP_R             100000
#define RBAT_PULL_DOWN_R           100000000
#endif
#define RBAT_PULL_UP_VOLT          1800


/* ============================================================*/
/* ENUM*/
/* ============================================================*/

/* ============================================================*/
/* structure*/
/* ============================================================*/

/* ============================================================*/
/* typedef*/
/* ============================================================*/
typedef struct _BATTERY_PROFILE_STRUCT {
	signed int percentage;
	signed int voltage;
} BATTERY_PROFILE_STRUCT, *BATTERY_PROFILE_STRUCT_P;

typedef struct _R_PROFILE_STRUCT {
	signed int resistance;
	signed int voltage;
} R_PROFILE_STRUCT, *R_PROFILE_STRUCT_P;

typedef enum {
	T1_0C,
	T2_25C,
	T3_50C
} PROFILE_TEMPERATURE;

/* ============================================================*/
/* External Variables*/
/* ============================================================*/

/* ============================================================*/
/* External function*/
/* ============================================================*/

/* ============================================================*/
/* <DOD, Battery_Voltage> Table*/
/* ============================================================*/
#if (BAT_NTC_10 == 1)
BATT_TEMPERATURE Batt_Temperature_Table[] = {
		{-20 , 75022},
		{-15 , 57926},
		{-10 , 45168},
		{ -5 , 35548},
		{  0 , 28224},
		{  5 , 22595},
		{ 10 , 18231},
		{ 15 , 14820},
		{ 20 , 12133},
		{ 25 , 10000},
		{ 30 , 8295},
		{ 35 , 6922},
		{ 40 , 5810},
		{ 45 , 4903},
		{ 50 , 4160},
		{ 55 , 3547},
		{ 60 , 3039}
};
#endif

#if (BAT_NTC_47 == 1)
BATT_TEMPERATURE Batt_Temperature_Table[] = {
		{-20, 483954},
		{-15, 360850},
		{-10, 271697},
		{ -5, 206463},
		{  0, 158214},
		{  5, 122259},
		{ 10, 95227},
		{ 15, 74730},
		{ 20, 59065},
		{ 25, 47000},
		{ 30, 37643},
		{ 35, 30334},
		{ 40, 24591},
		{ 45, 20048},
		{ 50, 16433},
		{ 55, 13539},
		{ 60, 11210}
};
#endif

#if (BAT_NTC_100 == 1)
BATT_TEMPERATURE Batt_Temperature_Table[] = {
		{-20, 1151037},
		{-15, 846579},
		{-10, 628988},
		{ -5, 471632},
		{  0, 357012},
		{  5, 272500},
		{ 10, 209710},
		{ 15, 162651},
		{ 20, 127080},
		{ 25, 100000},
		{ 30, 79222},
		{ 35, 63167},
		{ 40, 50677},
		{ 45, 40904},
		{ 50, 33195},
		{ 55, 27091},
		{ 60, 22224}
};
#endif

/* T0 -10C*/
BATTERY_PROFILE_STRUCT battery_profile_t0[] = {
		{0  , 4249},
		{1  , 4233},
		{2  , 4219},
		{3  , 4208},
		{4  , 4197},
		{5  , 4186},
		{6  , 4176},
		{7  , 4166},
		{8  , 4155},
		{9  , 4145},
		{10 , 4135},
		{11 , 4125},
		{12 , 4116},
		{13 , 4107},
		{14 , 4098},
		{15 , 4091},
		{16 , 4085},
		{17 , 4079},
		{18 , 4071},
		{19 , 4061},
		{20 , 4047},
		{21 , 4029},
		{22 , 4012},
		{23 , 3998},
		{24 , 3986},
		{25 , 3977},
		{26 , 3970},
		{27 , 3964},
		{28 , 3959},
		{29 , 3954},
		{30 , 3950},
		{31 , 3946},
		{32 , 3941},
		{33 , 3936},
		{34 , 3929},
		{35 , 3922},
		{36 , 3914},
		{37 , 3906},
		{38 , 3897},
		{39 , 3887},
		{40 , 3878},
		{41 , 3870},
		{42 , 3862},
		{43 , 3856},
		{44 , 3850},
		{45 , 3845},
		{46 , 3840},
		{47 , 3835},
		{48 , 3831},
		{49 , 3827},
		{50 , 3823},
		{51 , 3819},
		{52 , 3816},
		{53 , 3812},
		{54 , 3809},
		{55 , 3806},
		{56 , 3803},
		{57 , 3801},
		{58 , 3798},
		{59 , 3796},
		{60 , 3793},
		{61 , 3791},
		{62 , 3789},
		{63 , 3788},
		{64 , 3786},
		{65 , 3785},
		{66 , 3784},
		{67 , 3783},
		{68 , 3781},
		{69 , 3780},
		{70 , 3779},
		{71 , 3778},
		{72 , 3776},
		{73 , 3774},
		{74 , 3772},
		{75 , 3769},
		{76 , 3766},
		{77 , 3763},
		{78 , 3760},
		{79 , 3756},
		{80 , 3752},
		{81 , 3748},
		{82 , 3743},
		{83 , 3738},
		{84 , 3733},
		{85 , 3727},
		{86 , 3722},
		{87 , 3714},
		{88 , 3708},
		{89 , 3704},
		{90 , 3701},
		{91 , 3699},
		{92 , 3697},
		{93 , 3695},
		{94 , 3692},
		{95 , 3682},
		{96 , 3659},
		{97 , 3621},
		{98 , 3568},
		{99 , 3496},
		{100, 3400}
};

/* T1 0C*/
BATTERY_PROFILE_STRUCT battery_profile_t1[] = {
		{0  , 4249},
		{1  , 4233},
		{2  , 4219},
		{3  , 4208},
		{4  , 4197},
		{5  , 4186},
		{6  , 4176},
		{7  , 4166},
		{8  , 4155},
		{9  , 4145},
		{10 , 4135},
		{11 , 4125},
		{12 , 4116},
		{13 , 4107},
		{14 , 4098},
		{15 , 4091},
		{16 , 4085},
		{17 , 4079},
		{18 , 4071},
		{19 , 4061},
		{20 , 4047},
		{21 , 4029},
		{22 , 4012},
		{23 , 3998},
		{24 , 3986},
		{25 , 3977},
		{26 , 3970},
		{27 , 3964},
		{28 , 3959},
		{29 , 3954},
		{30 , 3950},
		{31 , 3946},
		{32 , 3941},
		{33 , 3936},
		{34 , 3929},
		{35 , 3922},
		{36 , 3914},
		{37 , 3906},
		{38 , 3897},
		{39 , 3887},
		{40 , 3878},
		{41 , 3870},
		{42 , 3862},
		{43 , 3856},
		{44 , 3850},
		{45 , 3845},
		{46 , 3840},
		{47 , 3835},
		{48 , 3831},
		{49 , 3827},
		{50 , 3823},
		{51 , 3819},
		{52 , 3816},
		{53 , 3812},
		{54 , 3809},
		{55 , 3806},
		{56 , 3803},
		{57 , 3801},
		{58 , 3798},
		{59 , 3796},
		{60 , 3793},
		{61 , 3791},
		{62 , 3789},
		{63 , 3788},
		{64 , 3786},
		{65 , 3785},
		{66 , 3784},
		{67 , 3783},
		{68 , 3781},
		{69 , 3780},
		{70 , 3779},
		{71 , 3778},
		{72 , 3776},
		{73 , 3774},
		{74 , 3772},
		{75 , 3769},
		{76 , 3766},
		{77 , 3763},
		{78 , 3760},
		{79 , 3756},
		{80 , 3752},
		{81 , 3748},
		{82 , 3743},
		{83 , 3738},
		{84 , 3733},
		{85 , 3727},
		{86 , 3722},
		{87 , 3714},
		{88 , 3708},
		{89 , 3704},
		{90 , 3701},
		{91 , 3699},
		{92 , 3697},
		{93 , 3695},
		{94 , 3692},
		{95 , 3682},
		{96 , 3659},
		{97 , 3621},
		{98 , 3568},
		{99 , 3496},
		{100, 3400}
};

/* T2 25C*/
BATTERY_PROFILE_STRUCT battery_profile_t2[] = {
		{0  , 4304},
		{1  , 4289},
		{2  , 4275},
		{3  , 4262},
		{4  , 4251},
		{5  , 4239},
		{6  , 4228},
		{7  , 4217},
		{8  , 4206},
		{9  , 4195},
		{10 , 4185},
		{11 , 4174},
		{12 , 4164},
		{13 , 4154},
		{14 , 4143},
		{15 , 4133},
		{16 , 4123},
		{17 , 4112},
		{18 , 4102},
		{19 , 4092},
		{20 , 4083},
		{21 , 4075},
		{22 , 4070},
		{23 , 4064},
		{24 , 4055},
		{25 , 4040},
		{26 , 4022},
		{27 , 4007},
		{28 , 3995},
		{29 , 3986},
		{30 , 3978},
		{31 , 3974},
		{32 , 3970},
		{33 , 3967},
		{34 , 3962},
		{35 , 3955},
		{36 , 3948},
		{37 , 3941},
		{38 , 3933},
		{39 , 3926},
		{40 , 3917},
		{41 , 3908},
		{42 , 3899},
		{43 , 3888},
		{44 , 3878},
		{45 , 3869},
		{46 , 3861},
		{47 , 3854},
		{48 , 3849},
		{49 , 3843},
		{50 , 3838},
		{51 , 3833},
		{52 , 3829},
		{53 , 3825},
		{54 , 3821},
		{55 , 3817},
		{56 , 3813},
		{57 , 3810},
		{58 , 3807},
		{59 , 3804},
		{60 , 3800},
		{61 , 3798},
		{62 , 3795},
		{63 , 3792},
		{64 , 3790},
		{65 , 3787},
		{66 , 3785},
		{67 , 3783},
		{68 , 3780},
		{69 , 3778},
		{70 , 3776},
		{71 , 3773},
		{72 , 3770},
		{73 , 3767},
		{74 , 3764},
		{75 , 3760},
		{76 , 3757},
		{77 , 3753},
		{78 , 3749},
		{79 , 3746},
		{80 , 3743},
		{81 , 3740},
		{82 , 3736},
		{83 , 3731},
		{84 , 3725},
		{85 , 3720},
		{86 , 3715},
		{87 , 3709},
		{88 , 3701},
		{89 , 3695},
		{90 , 3692},
		{91 , 3691},
		{92 , 3689},
		{93 , 3688},
		{94 , 3685},
		{95 , 3678},
		{96 , 3659},
		{97 , 3621},
		{98 , 3569},
		{99 , 3499},
		{100, 3400}
};

/* T3 50C*/
BATTERY_PROFILE_STRUCT battery_profile_t3[] = {
		{0  , 4309},
		{1  , 4294},
		{2  , 4279},
		{3  , 4266},
		{4  , 4254},
		{5  , 4242},
		{6  , 4231},
		{7  , 4219},
		{8  , 4208},
		{9  , 4197},
		{10 , 4187},
		{11 , 4176},
		{12 , 4165},
		{13 , 4155},
		{14 , 4144},
		{15 , 4134},
		{16 , 4124},
		{17 , 4114},
		{18 , 4104},
		{19 , 4094},
		{20 , 4084},
		{21 , 4074},
		{22 , 4065},
		{23 , 4055},
		{24 , 4046},
		{25 , 4037},
		{26 , 4028},
		{27 , 4018},
		{28 , 4010},
		{29 , 4002},
		{30 , 3994},
		{31 , 3986},
		{32 , 3978},
		{33 , 3970},
		{34 , 3963},
		{35 , 3955},
		{36 , 3948},
		{37 , 3941},
		{38 , 3934},
		{39 , 3927},
		{40 , 3919},
		{41 , 3912},
		{42 , 3903},
		{43 , 3892},
		{44 , 3880},
		{45 , 3870},
		{46 , 3862},
		{47 , 3855},
		{48 , 3849},
		{49 , 3844},
		{50 , 3839},
		{51 , 3834},
		{52 , 3829},
		{53 , 3825},
		{54 , 3821},
		{55 , 3817},
		{56 , 3813},
		{57 , 3809},
		{58 , 3806},
		{59 , 3802},
		{60 , 3799},
		{61 , 3796},
		{62 , 3793},
		{63 , 3790},
		{64 , 3787},
		{65 , 3785},
		{66 , 3782},
		{67 , 3780},
		{68 , 3778},
		{69 , 3775},
		{70 , 3772},
		{71 , 3767},
		{72 , 3760},
		{73 , 3753},
		{74 , 3748},
		{75 , 3744},
		{76 , 3740},
		{77 , 3736},
		{78 , 3732},
		{79 , 3729},
		{80 , 3726},
		{81 , 3723},
		{82 , 3719},
		{83 , 3715},
		{84 , 3709},
		{85 , 3703},
		{86 , 3698},
		{87 , 3692},
		{88 , 3685},
		{89 , 3679},
		{90 , 3676},
		{91 , 3675},
		{92 , 3674},
		{93 , 3673},
		{94 , 3670},
		{95 , 3663},
		{96 , 3642},
		{97 , 3605},
		{98 , 3556},
		{99 , 3492},
		{100, 3400}
};

/* battery profile for actual temperature. The size should be the same as T1, T2 and T3*/
BATTERY_PROFILE_STRUCT battery_profile_temperature[] = {
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
};

/* ============================================================*/
/* <Rbat, Battery_Voltage> Table*/
/* ============================================================*/
/* T0 -10C*/
R_PROFILE_STRUCT r_profile_t0[] = {
		{1073, 4249},
		{1073, 4233},
		{1089, 4219},
		{1110, 4208},
		{1123, 4197},
		{1132, 4186},
		{1139, 4176},
		{1146, 4166},
		{1152, 4155},
		{1158, 4145},
		{1162, 4135},
		{1165, 4125},
		{1167, 4116},
		{1169, 4107},
		{1173, 4098},
		{1180, 4091},
		{1191, 4085},
		{1204, 4079},
		{1213, 4071},
		{1213, 4061},
		{1202, 4047},
		{1181, 4029},
		{1164, 4012},
		{1156, 3998},
		{1153, 3986},
		{1155, 3977},
		{1160, 3970},
		{1166, 3964},
		{1173, 3959},
		{1181, 3954},
		{1189, 3950},
		{1195, 3946},
		{1197, 3941},
		{1197, 3936},
		{1195, 3929},
		{1190, 3922},
		{1182, 3914},
		{1172, 3906},
		{1159, 3897},
		{1146, 3887},
		{1135, 3878},
		{1124, 3870},
		{1119, 3862},
		{1116, 3856},
		{1115, 3850},
		{1117, 3845},
		{1118, 3840},
		{1120, 3835},
		{1122, 3831},
		{1126, 3827},
		{1129, 3823},
		{1133, 3819},
		{1137, 3816},
		{1142, 3812},
		{1147, 3809},
		{1152, 3806},
		{1157, 3803},
		{1162, 3801},
		{1168, 3798},
		{1174, 3796},
		{1179, 3793},
		{1185, 3791},
		{1192, 3789},
		{1198, 3788},
		{1205, 3786},
		{1213, 3785},
		{1222, 3784},
		{1231, 3783},
		{1241, 3781},
		{1250, 3780},
		{1260, 3779},
		{1270, 3778},
		{1281, 3776},
		{1291, 3774},
		{1301, 3772},
		{1312, 3769},
		{1324, 3766},
		{1336, 3763},
		{1352, 3760},
		{1369, 3756},
		{1388, 3752},
		{1408, 3748},
		{1429, 3743},
		{1451, 3738},
		{1477, 3733},
		{1506, 3727},
		{1538, 3722},
		{1568, 3714},
		{1604, 3708},
		{1645, 3704},
		{1695, 3701},
		{1753, 3699},
		{1821, 3697},
		{1900, 3695},
		{1992, 3692},
		{2097, 3682},
		{2197, 3659},
		{2308, 3621},
		{2457, 3568},
		{2648, 3496},
		{2617, 3400}
};
/* T1 0C*/
R_PROFILE_STRUCT r_profile_t1[] = {
		{1073, 4249},
		{1073, 4233},
		{1089, 4219},
		{1110, 4208},
		{1123, 4197},
		{1132, 4186},
		{1139, 4176},
		{1146, 4166},
		{1152, 4155},
		{1158, 4145},
		{1162, 4135},
		{1165, 4125},
		{1167, 4116},
		{1169, 4107},
		{1173, 4098},
		{1180, 4091},
		{1191, 4085},
		{1204, 4079},
		{1213, 4071},
		{1213, 4061},
		{1202, 4047},
		{1181, 4029},
		{1164, 4012},
		{1156, 3998},
		{1153, 3986},
		{1155, 3977},
		{1160, 3970},
		{1166, 3964},
		{1173, 3959},
		{1181, 3954},
		{1189, 3950},
		{1195, 3946},
		{1197, 3941},
		{1197, 3936},
		{1195, 3929},
		{1190, 3922},
		{1182, 3914},
		{1172, 3906},
		{1159, 3897},
		{1146, 3887},
		{1135, 3878},
		{1124, 3870},
		{1119, 3862},
		{1116, 3856},
		{1115, 3850},
		{1117, 3845},
		{1118, 3840},
		{1120, 3835},
		{1122, 3831},
		{1126, 3827},
		{1129, 3823},
		{1133, 3819},
		{1137, 3816},
		{1142, 3812},
		{1147, 3809},
		{1152, 3806},
		{1157, 3803},
		{1162, 3801},
		{1168, 3798},
		{1174, 3796},
		{1179, 3793},
		{1185, 3791},
		{1192, 3789},
		{1198, 3788},
		{1205, 3786},
		{1213, 3785},
		{1222, 3784},
		{1231, 3783},
		{1241, 3781},
		{1250, 3780},
		{1260, 3779},
		{1270, 3778},
		{1281, 3776},
		{1291, 3774},
		{1301, 3772},
		{1312, 3769},
		{1324, 3766},
		{1336, 3763},
		{1352, 3760},
		{1369, 3756},
		{1388, 3752},
		{1408, 3748},
		{1429, 3743},
		{1451, 3738},
		{1477, 3733},
		{1506, 3727},
		{1538, 3722},
		{1568, 3714},
		{1604, 3708},
		{1645, 3704},
		{1695, 3701},
		{1753, 3699},
		{1821, 3697},
		{1900, 3695},
		{1992, 3692},
		{2097, 3682},
		{2197, 3659},
		{2308, 3621},
		{2457, 3568},
		{2648, 3496},
		{2617, 3400}
};
/* T2 25C*/
R_PROFILE_STRUCT r_profile_t2[] = {
		{325, 4304},
		{325, 4289},
		{325, 4275},
		{326, 4262},
		{326, 4251},
		{325, 4239},
		{326, 4228},
		{326, 4217},
		{326, 4206},
		{326, 4195},
		{327, 4185},
		{327, 4174},
		{328, 4164},
		{329, 4154},
		{331, 4143},
		{332, 4133},
		{333, 4123},
		{334, 4112},
		{336, 4102},
		{339, 4092},
		{342, 4083},
		{347, 4075},
		{360, 4070},
		{368, 4064},
		{366, 4055},
		{354, 4040},
		{344, 4022},
		{342, 4007},
		{344, 3995},
		{346, 3986},
		{349, 3978},
		{357, 3974},
		{367, 3970},
		{374, 3967},
		{374, 3962},
		{373, 3955},
		{374, 3948},
		{377, 3941},
		{379, 3933},
		{380, 3926},
		{378, 3917},
		{373, 3908},
		{362, 3899},
		{349, 3888},
		{334, 3878},
		{322, 3869},
		{316, 3861},
		{312, 3854},
		{310, 3849},
		{309, 3843},
		{308, 3838},
		{308, 3833},
		{308, 3829},
		{309, 3825},
		{310, 3821},
		{311, 3817},
		{312, 3813},
		{314, 3810},
		{315, 3807},
		{316, 3804},
		{318, 3800},
		{320, 3798},
		{322, 3795},
		{325, 3792},
		{327, 3790},
		{329, 3787},
		{329, 3785},
		{331, 3783},
		{332, 3780},
		{333, 3778},
		{334, 3776},
		{333, 3773},
		{330, 3770},
		{326, 3767},
		{323, 3764},
		{323, 3760},
		{323, 3757},
		{324, 3753},
		{324, 3749},
		{325, 3746},
		{329, 3743},
		{333, 3740},
		{336, 3736},
		{337, 3731},
		{338, 3725},
		{341, 3720},
		{346, 3715},
		{350, 3709},
		{352, 3701},
		{353, 3695},
		{358, 3692},
		{365, 3691},
		{375, 3689},
		{386, 3688},
		{399, 3685},
		{411, 3678},
		{420, 3659},
		{437, 3621},
		{468, 3569},
		{517, 3499},
		{607, 3400}
};
/* T3 50C*/
R_PROFILE_STRUCT r_profile_t3[] = {
		{221, 4309},
		{221, 4294},
		{221, 4279},
		{221, 4266},
		{221, 4254},
		{221, 4242},
		{220, 4231},
		{221, 4219},
		{221, 4208},
		{221, 4197},
		{221, 4187},
		{223, 4176},
		{223, 4165},
		{224, 4155},
		{224, 4144},
		{224, 4134},
		{225, 4124},
		{225, 4114},
		{226, 4104},
		{227, 4094},
		{228, 4084},
		{228, 4074},
		{229, 4065},
		{230, 4055},
		{231, 4046},
		{233, 4037},
		{234, 4028},
		{234, 4018},
		{236, 4010},
		{239, 4002},
		{238, 3994},
		{240, 3986},
		{241, 3978},
		{242, 3970},
		{245, 3963},
		{248, 3955},
		{251, 3948},
		{254, 3941},
		{257, 3934},
		{261, 3927},
		{264, 3919},
		{267, 3912},
		{265, 3903},
		{255, 3892},
		{242, 3880},
		{232, 3870},
		{227, 3862},
		{225, 3855},
		{224, 3849},
		{223, 3844},
		{223, 3839},
		{224, 3834},
		{224, 3829},
		{224, 3825},
		{225, 3821},
		{225, 3817},
		{226, 3813},
		{227, 3809},
		{228, 3806},
		{229, 3802},
		{230, 3799},
		{231, 3796},
		{233, 3793},
		{234, 3790},
		{236, 3787},
		{238, 3785},
		{239, 3782},
		{241, 3780},
		{245, 3778},
		{246, 3775},
		{246, 3772},
		{239, 3767},
		{230, 3760},
		{226, 3753},
		{227, 3748},
		{228, 3744},
		{229, 3740},
		{229, 3736},
		{228, 3732},
		{228, 3729},
		{229, 3726},
		{230, 3723},
		{231, 3719},
		{230, 3715},
		{230, 3709},
		{230, 3703},
		{232, 3698},
		{232, 3692},
		{232, 3685},
		{230, 3679},
		{232, 3676},
		{234, 3675},
		{237, 3674},
		{240, 3673},
		{242, 3670},
		{243, 3663},
		{248, 3642},
		{258, 3605},
		{275, 3556},
		{302, 3492},
		{351, 3400}
};
/* r-table profile for actual temperature. The size should be the same as T1, T2 and T3*/
R_PROFILE_STRUCT r_profile_temperature[] = {
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
		{0, 0},
};

/* ============================================================*/
/* function prototype*/
/* ============================================================*/
int fgauge_get_saddles(void);
BATTERY_PROFILE_STRUCT_P fgauge_get_profile(unsigned int temperature);

int fgauge_get_saddles_r_table(void);
R_PROFILE_STRUCT_P fgauge_get_profile_r_table(unsigned int temperature);

#endif	/*#ifndef _CUST_BATTERY_METER_TABLE_H*/

